import { TraceSource } from "@implab/core-amd/log/TraceSource";

const delegate = <T extends { [p in K]: (...args: unknown[]) => unknown }, K extends string>(target: T, key: K): OmitThisParameter<T[K]> => target[key].bind(target) as OmitThisParameter<T[K]>;

export const log = (trace: TraceSource) => delegate(trace, "log");

export const debug = (trace: TraceSource) => delegate(trace, "debug");

export const warn = (trace: TraceSource) => delegate(trace, "warn");

export const error = (trace: TraceSource) => delegate(trace, "error");
